#!/bin/sh

CC=${CROSS_COMPILE}gcc
OBJDUMP=${CROSS_COMPILE}objdump

OBJDIR=`${CC} -dumpmachine`

if [[ ! -d ${OBJDIR} ]] ; then
	mkdir ${OBJDIR} || exit 1
fi

cd ${OBJDIR} || exit 1

${CC} -S -Os -fomit-frame-pointer -c ../walk_int8.c ../walk_int16.c ../walk_int32.c ../walk_int64.c || exit 1
# x86: replacing dependent reads with independent:
#sed 's/^\tor/\tmov/' -i walk_int*.s
${CC}    -Os -fomit-frame-pointer -c    walk_int8.s    walk_int16.s    walk_int32.s    walk_int64.s || exit 1
${OBJDUMP} -dr walk_int8.o    >walk_int8.disasm
${OBJDUMP} -dr walk_int16.o   >walk_int16.disasm
${OBJDUMP} -dr walk_int32.o   >walk_int32.disasm
${OBJDUMP} -dr walk_int64.o   >walk_int64.disasm

${CC} -S -Os -fomit-frame-pointer -c ../write_int8.c ../write_int16.c ../write_int32.c ../write_int64.c || exit 1
${CC}    -Os -fomit-frame-pointer -c    write_int8.s    write_int16.s    write_int32.s    write_int64.s || exit 1
${OBJDUMP} -dr write_int8.o    >write_int8.disasm
${OBJDUMP} -dr write_int16.o   >write_int16.disasm
${OBJDUMP} -dr write_int32.o   >write_int32.disasm
${OBJDUMP} -dr write_int64.o   >write_int64.disasm

${CC} -Wall -Os -fomit-frame-pointer -c ../measure.c || exit 1
${OBJDUMP} -dr measure.o >measure.disasm

${CC} -Os -fomit-frame-pointer -static -o measure measure.o \
	walk_int8.o walk_int16.o walk_int32.o walk_int64.o \
	write_int8.o write_int16.o write_int32.o write_int64.o \
    || exit 1
